library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity vga is
    Port (    
           clk : in std_logic;
           res : in std_logic;
		 number : in  std_logic_vector(7 downto 0);
		 control : in  std_logic_vector(7 downto 0);
		 HS : out std_logic;
           VS : out std_logic;
           R : out std_logic;
           G : out std_logic;
           B : out std_logic );
    end vga;

architecture Behavioral of vga is

	signal h_count	: Integer range 0 to 2048;
	signal v_count	: Integer range 0 to 1024;

     begin

	process (clk)
	begin
	    if clk = '1' and clk'Event then
           if res = '1' then
	        h_count <= 0;
	        v_count <= 0;
	        HS <= '1';
	        VS <= '1';
	        R  <= '0';
	        G  <= '0';
	        B  <= '0';
           else 

		   if(h_count>=1598) then 
		     h_count <= 0;
		   else 
		     h_count <= h_count + 1;
		   end if;

		   if(h_count>=1318 and h_count<=1510) then 
		     HS <= '0';
		   else 
		     HS <= '1';
		   end if;

		   if(v_count>=524 and h_count>=1398) then 
		     v_count <= 0;
		   elsif (h_count = 1398) then 
		     v_count <= v_count+1;
		   end if;

		   if(v_count<=494 and v_count>=493) then 
		     VS <= '0';
		   else 
		     VS <= '1';
		   end if;	     

		   
		   -------------------------
		   R  <= '0';
	        G  <= '0';
	        B  <= '0';

 		  -- negative number
		  if control = "11111111" then
			if(h_count>=50 and h_count<=150 and  v_count>=240 and v_count<=265) then 
		    		R <= '1';
		  	end if;
		  end if;
		   --overflow
		  if control = "00001111" then
			 --letra O
			 if(h_count>=200 and h_count<=250 and  v_count>=50 and v_count<=450) then 
			   G <= '1';
			 end if;
			 if(h_count>=450 and h_count<=500 and  v_count>=50 and v_count<=450) then 
			   G <= '1';
			 end if;
			 if(h_count>=200 and h_count<=500 and  v_count>=425 and v_count<=450) then 
			   G <= '1';
			 end if;
			 if(h_count>=200 and h_count<=500 and  v_count>=50 and v_count<=75) then 
			   G <= '1';
			 end if;

			 --letra F
	        	 if(h_count>=550 and h_count<=600 and  v_count>=50 and v_count<=450) then 
      			G <= '1';
			 end if;
			 if(h_count>=550 and h_count<=875 and  v_count>=50 and v_count<=75) then 
				G <= '1';
			 end if;
			 if(h_count>=550 and h_count<=875 and  v_count>=240 and v_count<=265) then 
				G <= '1';
			 end if;

		  else	  
		  						   		  
			   -- NUMERO OITO DA ESQUERDA
			   --risco esquerda superior
			   --liga para todos, menos para 1,2,3,7,d
			 if(h_count>=200 and h_count<=250 and  v_count>=50 and v_count<=250) then 
			   	B <= '1';
			   	if( number(7 downto 4) ="0001" 
				  or number(7 downto 4) ="0010"
				  or number(7 downto 4) ="0011"
				  or number(7 downto 4) ="0111" 
				  or number(7 downto 4) ="1101")then
				  B <= '0';
				end if;
			   
			 end if;

			   --risco esquerda inferior				   			
			 if(h_count>=200 and h_count<=250 and  v_count>=250 and v_count<=450) then 
			     B <= '1';
			   	if( number(7 downto 4) ="0001" 
				  or number(7 downto 4) ="0011"
				  or number(7 downto 4) ="0100"
				  or number(7 downto 4) ="0101" 
				  or number(7 downto 4) ="0111"
				  or number(7 downto 4) ="1001")then
				  B <= '0';
				end if;
			 end if;

			   --risco diretita superior
			 if(h_count>=450 and h_count<=500 and  v_count>=50 and v_count<=250) then 
			     B <= '1';
			   	if( number(7 downto 4) ="0101" 
				  or number(7 downto 4) ="0110"
				  or number(7 downto 4) ="1011"
				  or number(7 downto 4) ="1100" 
				  or number(7 downto 4) ="1110"
				  or number(7 downto 4) ="1111")then
				  B <= '0';
				end if;
			 end if;

			   --risco direita inferior				   
			 if(h_count>=450 and h_count<=500 and  v_count>=250 and v_count<=450) then 
			     B <= '1';
			   	if( number(7 downto 4) ="0010" 
				  or number(7 downto 4) ="1100"
				  or number(7 downto 4) ="1110"
				  or number(7 downto 4) ="1111")then
				  B <= '0';
				end if;
			 end if;

			   --risco de baixo
			 if(h_count>250 and h_count<450 and  v_count>=425 and v_count<=450) then 
			     B <= '1';
			   	if( number(7 downto 4) ="0001" 
				  or number(7 downto 4) ="0100"
				  or number(7 downto 4) ="0111"
				  or number(7 downto 4) ="1010" 
				  or number(7 downto 4) ="1111" )then
				  B <= '0';
				end if;
			 end if;

			  -- risco de cima
			 if(h_count>250 and h_count<450 and  v_count>=50 and v_count<=75) then 
			     B <= '1';
			   	if( number(7 downto 4) ="0001" 
				  or number(7 downto 4) ="0100"
				  or number(7 downto 4) ="1011"
				  or number(7 downto 4) ="1101")then
				  B <= '0';
				end if;
			 end if;

			 -- risco do meio
			 if(h_count>250 and h_count<450 and  v_count>=240 and v_count<=265) then 
			     B <= '1';
			   	if( number(7 downto 4) ="0000" 
				  or number(7 downto 4) ="0001"
				  or number(7 downto 4) ="0111"
				  or number(7 downto 4) ="1100")then
				  B <= '0';
				end if;
			 end if;
										

			-- NUMERO OITO DA DIREITA
			 --risco da esquerda superior
			if(h_count>=550 and h_count<=600 and  v_count>=50 and v_count<=250) then 
				B <= '1';
			   	if( number(3 downto 0) ="0001" 
				  or number(3 downto 0) ="0010"
				  or number(3 downto 0) ="0011"
				  or number(3 downto 0) ="0111" 
				  or number(3 downto 0) ="1101")then
				  B <= '0';
				end if;
			end if;

			--risco da esquerda inferior
			if(h_count>=550 and h_count<=600 and  v_count>=250 and v_count<=450) then 
			  	B <= '1';
			   	if( number(3 downto 0) ="0001" 
				  or number(3 downto 0) ="0011"
				  or number(3 downto 0) ="0100"
				  or number(3 downto 0) ="0101" 
				  or number(3 downto 0) ="0111"
				  or number(3 downto 0) ="1001")then
				  B <= '0';
				end if;
			end if;

			--risco da direita superior
			if(h_count>=825 and h_count<=875 and  v_count>=50 and v_count<=250) then 
				B <= '1';
			   	if( number(3 downto 0) ="0101" 
				  or number(3 downto 0) ="0110"
				  or number(3 downto 0) ="1011"
				  or number(3 downto 0) ="1100" 
				  or number(3 downto 0) ="1110"
				  or number(3 downto 0) ="1111")then
				  B <= '0';
				end if;
			end if;

			--risco da direita inferior
			if(h_count>=825 and h_count<=875 and  v_count>=250 and v_count<=450) then 
				B <= '1';
			   	if( number(3 downto 0) ="0010" 
				  or number(3 downto 0) ="1100"
				  or number(3 downto 0) ="1110"
				  or number(3 downto 0) ="1111")then
				  B <= '0';
				end if;
			end if;

			--risco de baixo
			if(h_count>600 and h_count<825 and  v_count>=425 and v_count<=450) then 
				B <= '1';
			   	if( number(3 downto 0) ="0001" 
				  or number(3 downto 0) ="0100"
				  or number(3 downto 0) ="0111"
				  or number(3 downto 0) ="1010" 
				  or number(3 downto 0) ="1111" )then
				  B <= '0';
				end if;
			end if;

			--risco de cima
			if(h_count>600 and h_count<825 and  v_count>=50 and v_count<=75) then 
				B <= '1';
			   	if( number(3 downto 0) ="0001" 
				  or number(3 downto 0) ="0100"
				  or number(3 downto 0) ="1011"
				  or number(3 downto 0) ="1101")then
				  B <= '0';
				end if;
			end if;

			--risco do meio
			if(h_count>600 and h_count<825 and  v_count>=240 and v_count<=265) then 
				B <= '1';
			   	if( number(3 downto 0) ="0000" 
				  or number(3 downto 0) ="0001"
				  or number(3 downto 0) ="0111"
				  or number(3 downto 0) ="1100")then
				  B <= '0';
				end if;
			end if;
		  end if;
         end if;
       end if;
	end process;
end Behavioral;